/* Operator dodele - vrednost izraza dodele */

#include <stdio.h>

int main() {
  int a, b, c;

  /* Vrednost izraza dodele je vrednost njegove desne strane, pri cemu
     se, kao bocni efekat, ta vrednost smesta na adresu (u
     promenljivu) odredjenu njegovom levom stranom. */

  /* Ovo omogucava ulancavanje (pri cemu je zagrade moguce izostaviti
     zbog ugradjene desne asocijativnosti. */
  a = b = c = 3;
  printf("a = %d, b = %d, c = %d\n", a, b, c);

  /* Vrednost dodele se moze, na primer, iskoristiti da se veoma
     kompaktno iskaze citanje karaktera do pojave nekog terminirajuceg
     karaktera */
  while((c = getchar()) != '\n') 
    putchar(c); 

  /* Operatori dodele su veoma niskog prioriteta - nizeg od
     relacijskih. Zato su zagrade u izrazu (c = getchar()) != '\n'
     neophodne */

  /* Prethodni kod je ekvivalentan sa:
    c = getchar();
    while (c != '\n') {
       putchar(c);
       c = getchar();
    }
  */
}
